/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

extern char **CopyArgv();

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app1, app2;
    Display *dpy1, *dpy2;
    XEvent  event;
    Widget  top1, rowcol1, button1, text1;
    Widget  top2, rowcol2, button2, text2;
    Arg     al[20];
    int     ac;
    int     argc2;
    char  **argv2;

    /* Copy the argc and argv */
    argv2 = CopyArgv(argc, argv);
    if (argv2 == NULL) argc2 = 0;
    else               argc2 = argc;

    XtToolkitInitialize();

    /* Create two application context */
    app1 = XtCreateApplicationContext();
    app2 = XtCreateApplicationContext();

    XtSetLanguageProc(NULL, NULL, NULL);

    /* Open the DISPLAY */
    dpy1 = XtOpenDisplay(app1, NULL,
                         NULL, "App1", NULL, 0, &argc, argv);
    /* Create widget tree on the DISPLAY */
    ac = 0;
    top1 = XtAppCreateShell(NULL, "App1", applicationShellWidgetClass,
                            dpy1, al, ac);
    ac = 0;
    rowcol1 = XmCreateRowColumn(top1, "rowcol1", al, ac);
    XtManageChild(rowcol1);
    ac = 0;
    button1 = XmCreatePushButton(rowcol1, "button1", al, ac);
    XtManageChild(button1);


    /* Open the DISPLAY2 */
    dpy2 = XtOpenDisplay(app2, getenv("DISPLAY2"),
                         NULL, "App2", NULL, 0, &argc2, argv2);

    /* Create widget tree on the DISPLAY2 */
    ac = 0;
    top2 = XtAppCreateShell(NULL, "App2", applicationShellWidgetClass,
                            dpy2, al, ac);
    ac = 0;
    rowcol2 = XmCreateRowColumn(top2, "rowcol2", al, ac);
    XtManageChild(rowcol2);
    ac = 0;
    button2 = XmCreatePushButton(rowcol2, "button2", al, ac);
    XtManageChild(button2);

    /* Realize both top level shells */
    XtRealizeWidget(top1);
    XtRealizeWidget(top2);

    /* Custom event loop */
    while (True) {
        /* Check events of both application context alternately */
        if (XtAppPending(app1)) {          /* If app1 has events, */
            XtAppNextEvent(app1, &event);  /* retrieve it from event que */
            XtDispatchEvent(&event);       /* and process the event */
        }
        else if (XtAppPending(app2)) {     /* If app2 has events, */
            XtAppNextEvent(app2, &event);  /* retrieve it from event que */
            XtDispatchEvent(&event);       /* and process the event */
        }
    }
}
