/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

static Atom wm_delete_window;  /* Atom of "WM_DELETE_WINDOW" */

/* Event handler which processes client message event */
static void ClientMsgEH(w, client_data, event, dispatch)
    Widget     w;
    XtPointer  client_data;
    XEvent    *event;
    Boolean   *dispatch;
{
    if (  event->type == ClientMessage &&  /* (2) event type */
          event->xclient.message_type ==   /* (3) message type */
                  XmInternAtom(XtDisplay(w), "WM_PROTOCOLS", False) &&
          event->xclient.data.l[0] == wm_delete_window  ) { /* (4) protocol */
        printf("Close button is selected\n");
        exit(0);  /* (5) Do appropreate work and exit */
    }
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, button;
    Arg    al[20];
    int    ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Nonmaskable", NULL, 0,
                               &argc, argv, NULL, al, ac);
    ac = 0;
    button = XmCreatePushButton(toplevel, "button", al, ac);
    XtManageChild(button);

    /* (1) Preparation for receiving event when Close button is selected */
    wm_delete_window = XmInternAtom(XtDisplay(toplevel),
                                    "WM_DELETE_WINDOW", False);
    XmAddWMProtocols(toplevel, &wm_delete_window, 1);
    XmActivateWMProtocol(toplevel, wm_delete_window);

    /* (1) Register an event handler for non-maskable event */
    XtAddEventHandler(toplevel, NoEventMask, True, ClientMsgEH, NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
